#include <SPI.h>              
#include <LoRa.h>
LoRaClass LoRa;

const int csPin = 7;          
const int resetPin = 6;       
const int irqPin = 1;         

String outgoing;              

long msgCount = 0;            
byte localAddress = 0x00;    
long lastSendTime = 0;       
int interval = 5000;          

const int num_chars = 512;
char received_chars[num_chars];
boolean new_data = false;

byte StrToHex(char str[])
{
  return (byte) strtol(str, 0, 16);
}

void setup() {
  Serial.begin(9600);             
  Serial1.begin(9600);  
  while (!Serial);
  if (!LoRa.begin(868E6)) {             
    while (true);                    
  }

}

void loop() {
  onReceive(LoRa.parsePacket());
  static boolean recv_in_progress = false;
    static byte ndx = 0;
    char startMarker = '|';
    char end_marker = '|';
    char rc;
    while (Serial.available() > 0 && new_data == false) {
        rc = Serial.read();
        if (recv_in_progress == true) {
            if (rc != end_marker) {
                received_chars[ndx] = rc;
                ndx++;
                if (ndx >= num_chars) {
                    ndx = num_chars - 1;
                }
            }
            else {
                received_chars[ndx] = '\0';
                recv_in_progress = false;
                ndx = 0;
                new_data = true;
            }
        }
        else if (rc == startMarker) {
            recv_in_progress = true;
        }
    }
    if (new_data == true) {
        char addr[2];
        memcpy(addr, received_chars, 2);
        byte address = StrToHex(addr);
        char* message = received_chars;
        message+=2;
        Serial.println(address);
        Serial.println(message);
        sendMessage(message,address);
        message = NULL;
        address =  NULL;
        new_data = false;
    }
}

void sendMessage(char payload[],byte destination) {
  String outgoing(payload);
  LoRa.beginPacket();                 
  LoRa.write(destination);              
  LoRa.write(localAddress);             
  LoRa.write(msgCount);                 
  LoRa.write(outgoing.length());        
  LoRa.print(outgoing);                
  LoRa.endPacket();                   
  msgCount++;                           
}

void onReceive(int packetSize) {
  if (packetSize == 0) return;          
  int recipient = LoRa.read();        
  byte sender = LoRa.read();           
  byte incomingMsgId = LoRa.read();   
  byte incomingLength = LoRa.read();   
  String incoming = "";
  while (LoRa.available()) {
    incoming += (char)LoRa.read();
  }
  if (incomingLength != incoming.length()) {  
    return;                            
  }
  if (recipient != localAddress && recipient != 0xFF) {
    return;                    
  }
  Serial.println("{\"NODE\":\"" + String(sender, HEX) + "\",\"PAYLOAD\":" + incoming + "}");
}

