<?php

function send_msg($msg){
    $rcv_msg = "";
    $timeout = 5;
	$file = 'unix:///var/www/html/tmp/iotgateway.sock';
	
	$socket = stream_socket_client('unix:///var/www/html/tmp/iotgateway.sock', $errorno, $errorstr, $timeout);
    stream_set_timeout($socket, $timeout);
    if(!fwrite($socket, $msg))
        //http_response_code(500);
        http_response_code(200);
		//echo '500 Internal Server Error2';
		//die();
    if (!($rcv_msg = fread($socket, 256))) 
		return null;
    else 
		return $rcv_msg;		
}


define ('HOST','localhost');
define ('DB_NAME','iot');
define ('DB_USER','XXXX');
define ('DB_PASS','XXXXXXXX');
define ('DB_CHARSET','utf8');

$location_name = null;
$node_name = null;
$sensor_name = null;

$uri = trim($_SERVER['REDIRECT_URL'],'/');
$request = $uri != '' ? explode('/', $uri) : null;
if ($uri != ''){
    $request = explode('/', $uri);
	
}
$request = is_array($request) ? array_map('strtoupper', $request) : null ;

$method = $_SERVER['REQUEST_METHOD'];
$input = json_decode(file_get_contents('php://input'),true);

try {
   $db = new PDO('mysql:host='.HOST.';dbname='.DB_NAME, DB_USER, DB_PASS); 
   $db->setAttribute( PDO::ATTR_EMULATE_PREPARES, false );
   $db->exec('SET CHARACTER SET '.DB_CHARSET);
} catch(PDOException $e){
	echo $e->getMessage();
} 

$format = isset($_GET['f']) ? $_GET['f'] : 'json'; 

$readings = 1;
$result = null;

if ($method == 'GET'){
	if (sizeof($request)>=1 ){
		$api = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
		if (sizeof($request)>=1 && $api =='API'){
			$version = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
			if (sizeof($request)>=1 && $version =='V1'){
				$location_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
				if (sizeof($request)>=1 ) {
					$node_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
					if (sizeof($request)>=1 ) {
						$sensor_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
						if (sizeof($request)>=1 ) {
							$modifier = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
							switch($modifier){
								case 'STATE': case 'GET': $readings = null;   break;
								case 'LAST': $readings = 1;	  break;
								case 'ALL':	$readings = $modifier <= 1000 ? $modifier : 1000;   break;
								default: if(is_numeric($modifier)){  $readings = $modifier <= 1000 ? $modifier : 1000; } break;
							}
						}
						if (is_null($readings)){
							$message = array('COMMAND'=>'GET', 
											 'TOPIC'=>$location_name.'/'.$node_name.'/'.$sensor_name);
							$response = send_msg(json_encode($message));
							header('Content-Type: application/json');
							echo $response;
							die();
						}else{
							$query = "SELECT * FROM data_full WHERE location_name = :location_name AND node_name = :node_name AND sensor_name = :sensor_name ORDER BY data_date DESC LIMIT :readings";
							$params = array(':location_name' => $location_name, ':node_name' => $node_name, ':sensor_name' => $sensor_name, ':readings'=>$readings);
							try { 
								$stm = $db->prepare($query); 
								$stm->execute($params); 
								$result = $stm->fetchAll(PDO::FETCH_ASSOC);
							} catch(PDOException $e){}
						}
					}else{
						$query = "SELECT DISTINCT sensor_name FROM sensor_full 
								  WHERE location_name = :location_name AND node_name = :node_name";
						$params = array(':location_name' => $location_name, ':node_name' => $node_name);
						try { 
							$stm = $db->prepare($query); 
							$stm->execute($params); 
							$result = $stm->fetchAll(PDO::FETCH_ASSOC);
						} catch(PDOException $e){}
					}
				}else{
					$query = "SELECT DISTINCT node_name FROM sensor_full WHERE location_name = :location_name";
					$params = array(':location_name' => $location_name);
					try { 
						$stm = $db->prepare($query); 
						$stm->execute($params); 
						$result = $stm->fetchAll(PDO::FETCH_ASSOC);
					} catch(PDOException $e){}
				}
			}else{
				$query = "SELECT DISTINCT location_name FROM sensor_full WHERE 1";
				try { 
					$stm = $db->prepare($query); 
					$stm->execute(); 
					$result = $stm->fetchAll(PDO::FETCH_ASSOC);
				} catch(PDOException $e){}
			}
		}

	}
	
}elseif($method == 'POST'){
	if (sizeof($request)>=1 ){
		$api = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
		if (sizeof($request)>=1 && $api =='API'){
			$version = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
			if (sizeof($request)>=1 ){
				$location_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
				if (sizeof($request)>=1 ) {
					$node_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
					if (sizeof($request)>=1 ) {
						$sensor_name = preg_replace('/[^a-z0-9_]+/i','',array_shift($request));
						$value = $_POST['VALUE'];
						$message = array('COMMAND'=>'SET', 
										 'TOPIC'=>$location_name.'/'.$node_name.'/'.$sensor_name,
										 'VALUE'=>$value );
						header('Content-Type: application/json');
						$response = send_msg(json_encode($message));
						echo $response;
						die();
					}else{}
				}else{}
			}else{}
		}else{}
	}else{}
}

if (sizeof($result)<1){
	http_response_code(404);
	echo '404 Not Found';
	die();
}else{
	if($format == 'json'){
		header('Content-Type: application/json');
		echo json_encode($result);
	}else{
		var_dump($result);
	}
}

