#include "Arduino.h"
#include "Node.h"


void  Node::set_location( char *node_location){
	this->_location = node_location;
}

void  Node::set_name( char *node_name){
	this->_name = node_name;
}


void Node::get_parameter_callback(char* (*get_parameter)(char* parameter)){
	this->get_parameter = get_parameter;
}

void Node::set_parameter_callback(bool  (*set_parameter)(char* parameter, char *value)){
	this->set_parameter = set_parameter;
}

void Node::describe_callback(void(*describe)(void)){
	this->describe = describe;
}

char* Node::to_char_buff( char* value){
	return value;
}

char* Node::to_char_buff( bool value){
	char *v = value ? "1" : "0";
	return v;
}

char* Node::to_char_buff( int value){
	char v[8]="";
	sprintf(v,"%d", value);
	return v;
}

char* Node::to_char_buff( long value){
	char v[16]="";
	sprintf(v,"%ld", value);
	return v;
}

char* Node::to_char_buff( unsigned long value){
	char v[16]="";
	sprintf(v,"%lu", value);
	return v;
}

char* Node::to_char_buff( long long value){
	char v[32]="";
	dtostrf (value, 0, 0, v);
	return v;
}

char* Node::to_char_buff( double value){
	char v[32]="";
	dtostrf (value, 0, 4, v);
	return v;
}

char* Node::to_char_buff( float value){
	char v[32]="";
	dtostrf (value, 0, 4, v);
	return v; 
}


Node::Node(){

}

char* Node::get_parameter_from_topic(char *topic) {
	char tpc[128]="";
	sprintf(tpc,"%s",topic);
	char param[64]="";
	char * pch;
    pch = strtok (tpc,"/");
    while (pch != NULL){
		sprintf (param,"%s", pch);
		pch = strtok (NULL, "/");
	}
	return param;
}

Topic Node::split_topic(char *topic){
	Topic tpc;
	char *end_topic;
	char *token = strtok_r(topic, "/", &end_topic);
	if (token != NULL) {
		strncpy(tpc.location, token, 40);
		token = strtok_r(NULL, "/", &end_topic);
		if (token != NULL) {
			strncpy(tpc.node, token, 40);
			token = strtok_r(NULL, "/", &end_topic);
			if (token != NULL) {
				strncpy(tpc.parameter, token, 40);
				token = strtok_r(NULL, "/", &end_topic);
				if (token != NULL) {
					strncpy(tpc.trail, token, 16);
					token = strtok_r(NULL, "/", &end_topic);
				}
			}
		}
	}
	return tpc;
}

Message Node::split_message(char *message){
	Message msg;
	char *end_payload;
	char *pair = strtok_r(message, "}{,", &end_payload);
	while (pair != NULL) {
		char *end_pair;
		char key[16]="";
		char val[128]="";
		sscanf(pair," \"%[^\"]\" : %s ", key, val);
		char *value = strtok_r(val, "\"", &end_pair);
		if (!strcmp(key, "COMMAND")){
			strncpy(msg.command, value, 16);
		}else if(!strcmp(key, "TOPIC")){
			strncpy(msg.topic, value, 128);
		}else if(!strcmp(key, "VALUE")){
			strncpy(msg.value, value, 128);
		}else if(!strcmp(key, "ID")){
			strncpy(msg.id, value, 32);
		}
		pair = strtok_r(NULL, "}{,", &end_payload);
	}
	return msg;
}

char* Node::generate_topic( char *parameter){
	char topic[128]="";
	sprintf(topic, "%s/%s/%s",this->_location, this->_name, parameter);
	return topic;
}

char* Node::generate_topic( char *parameter, char *action){
	char topic[128]="";
	sprintf(topic, "%s/%s/%s/%s",this->_location, this->_name, parameter, action);
	return topic;
}


