#include "Arduino.h"
#include "IPAddress.h"
#include "Node.h"
#include "coap.h"

class NodeCOAP : public Node {
	
  public:
  
	NodeCOAP();
	NodeCOAP(Coap&);
	
	void set_client(Coap&);
    void response_callback(void (*sus_callback)(CoapPacket&, IPAddress, int, char*));
    void subscribe_callback(void (*sus_callback)(CoapPacket&, IPAddress, int, char*));
    void subscribe_handle(CoapPacket&, IPAddress, int, char*);
  
	void init( IPAddress, uint16_t  );
	void loop();
	
	void subscribe(char*);
	void publish(char*, char*);
    void publish(char*, bool);
	void publish(char*, int);
	void publish(char*, long);
	void publish(char*, double);
	void publish(char*, float);

    void describe_parameter(char *, bool = false);
    void desc( char *parameter);

  private:
	
	Coap* _client;
	char* _protocol = "COAP";
    void (*sus_callback)(CoapPacket&, IPAddress, int, char*);
	IPAddress _gateway_address;
	uint16_t _port;	
	static void callback(char* topic, byte* payload, unsigned int length);
	char well_known[512];
    static void callback_resp(CoapPacket &packet, IPAddress ip, int port, char* url);

};

