#include "Arduino.h"
#include "NodeLORA.h"

NodeLORA::NodeLORA(){}

NodeLORA::NodeLORA(LoRaClass& LoRa){
	this->_client = &LoRa;
}

NodeLORA::NodeLORA( char *node_name,  char *node_location){
	set_name( *node_name );
	set_location( *node_location );
}

void NodeLORA::set_gateway_address( uint8_t gateway_address){
	this->_gateway_address = gateway_address;
}

void NodeLORA::set_node_address( uint8_t node_address){
	this->_node_address = node_address;
}

void NodeLORA::set_multicast_address( uint8_t multicast_taddress){
	this->_multicast_address = multicast_taddress;
}

void NodeLORA::init(){
	if (!LoRa.begin(868E6)) {
		while (true);
	}
}

void NodeLORA::init( uint8_t  gateway_address, uint8_t  node_address, uint8_t  multicast_address ){
	this->_gateway_address = gateway_address;
	this->_node_address = node_address; 
	this->_multicast_address = multicast_address;
	if (!LoRa.begin(868E6)) {           
		while (true);                     
	}
}

void NodeLORA::init( char *node_name,  char *node_location, uint8_t  gateway_address, uint8_t  node_address, uint8_t  multicast_address ){
	set_name( *node_name );
	set_location( *node_location );
	set_gateway_address( gateway_address );
	set_node_address( node_address );
	set_gateway_address( gateway_address );
	set_multicast_address( multicast_address );
	if (!LoRa.begin(868E6)) {           
		while (true);                     
	}
}

void NodeLORA::loop(){
	rx();
}

bool NodeLORA::tx(char payload[]) {
	Serial.println(payload);
    String str(payload);
	this->_client->beginPacket();
	this->_client->write(this->_gateway_address);
	this->_client->write(this->_node_address);
	this->_client->write(this->_msgCount);
	this->_client->write(str.length());
	this->_client->print(str);
	this->_client->endPacket();
    this->_msgCount++;                           
    return true;
}

void NodeLORA::rx() {
	int packetSize = this->_client->parsePacket();
    if (packetSize == 0) return;         
	int recipient = this->_client->read();
	byte sender = this->_client->read();
	byte incomingMsgId = this->_client->read();
	byte incomingLength = this->_client->read();
	String incoming = "";
	while (this->_client->available()) {
		incoming += (char)this->_client->read();
	}
	if (incomingLength != incoming.length()) return;                        
	if (recipient != this->_node_address && recipient != this->_multicast_address)  return;                            
	char *payload;
	incoming.toCharArray(payload, incoming.length() + 1);
	this->decode(payload); 
}
