#include "Arduino.h"
#include "IPAddress.h"
#include "NodeUART.h"
#include "LoRa.h"

class NodeLORA : public NodeUART {
	
  public:
	
	NodeLORA();
	NodeLORA(LoRaClass&);
	NodeLORA(char*, char*);
	
	void set_gateway_address(uint8_t);
	void set_node_address(uint8_t);
	void set_multicast_address(uint8_t);

	void init();
	void init(uint8_t, uint8_t, uint8_t);
	void init(char*, char*, uint8_t, uint8_t, uint8_t);
	void loop();

  private:
	LoRaClass* _client;
	char* _protocol = "LORA";
	uint8_t _gateway_address;
	uint8_t _node_address; 
	uint8_t _multicast_address;
	long _msgCount = 0;
	
	bool tx(char[]);
	void rx();

};



