#include "Arduino.h"
#include "IPAddress.h"
#include "Node.h"
#include "PubSubClient.h"

class NodeMQTT : public Node {
	
  public:
	
	NodeMQTT();
	NodeMQTT(PubSubClient&);
	
	void set_client(PubSubClient& client);
	void subscribe_callback(void (*callback)(char*, uint8_t*, unsigned int));
	bool subscribe_handle(char*, uint8_t*, unsigned int);

	void describe_parameter(char *, bool = false);
	
	void init( IPAddress, uint16_t);
	void loop();
	
	void subscribe(char*, char* = NULL);
	void publish(char*, char*, char* = NULL, char* = NULL);
	void publish(char*, bool, char* = NULL, char* = NULL);
	void publish(char*, int, char* = NULL, char* = NULL);
	void publish(char*, long, char* = NULL, char* = NULL);
	void publish(char*, double, char* = NULL, char* = NULL);
	void publish(char*, float, char* = NULL, char* = NULL);

  private:

	char* _protocol = "MQTT";
	PubSubClient* _client;
	long lastReconnectAttempt = 0;

	char* generate_payload(char* value, char* id = NULL);
	bool  reconnect();

};
