#include "Arduino.h"
#include "NodeZIGBEE.h"


NodeZIGBEE::NodeZIGBEE(){
}

NodeZIGBEE::NodeZIGBEE(XBee& client, ZBRxResponse& client_rx, ModemStatusResponse& client_msr){
	set_client(client, client_rx, client_msr);
}

void NodeZIGBEE::set_client(XBee& client, ZBRxResponse& client_rx, ModemStatusResponse& client_msr){
	this->_client = &client;
	this->_client_rx = &client_rx;
	this->_client_msr = &client_msr;
}

void NodeZIGBEE::init( Stream &serial ){
	this->_client->setSerial(serial);
}

void NodeZIGBEE::loop(){
	rx();
}

bool NodeZIGBEE::tx(char payload[]) {
      uint8_t length = strlen(payload);
      XBeeAddress64 addr64 = XBeeAddress64(0x00, 0x00);//, 0xFFFF
      ZBTxRequest zbTx = ZBTxRequest(addr64,(uint8_t*)payload, length);
      ZBTxStatusResponse txStatus = ZBTxStatusResponse();
      this->_client->send(zbTx);
      if (this->_client->readPacket(500)) {            
        if (this->_client->getResponse().getApiId() == ZB_TX_STATUS_RESPONSE) {
          this->_client->getResponse().getZBTxStatusResponse(txStatus);
          if (txStatus.getDeliveryStatus() == SUCCESS) {
            return true;
          } 
        }
      }
      return false;
    }
	
void NodeZIGBEE::rx() {
  this->_client->readPacket();
  if (this->_client->getResponse().isAvailable()) {
	if (this->_client->getResponse().getApiId() == ZB_RX_RESPONSE) {
	  this->_client->getResponse().getZBRxResponse(*this->_client_rx);
	  if (this->_client_rx->getOption() == ZB_PACKET_ACKNOWLEDGED) { } else { }
	  char* msg = this->_client_rx->getData();
	  this->decode(msg);
	} else if (this->_client->getResponse().getApiId() == MODEM_STATUS_RESPONSE) {
	  this->_client->getResponse().getModemStatusResponse(*_client_msr);
	  if (this->_client_msr->getStatus() == ASSOCIATED) { 
	  } else if (this->_client_msr->getStatus() == DISASSOCIATED) { } else { }
	} else { }
  } else if (this->_client->getResponse().isError()) { }  
}

